import _typeof from "@babel/runtime/helpers/typeof";
import "core-js/modules/es6.object.set-prototype-of";

var __extends = this && this.__extends || function () {
  var _extendStatics = function extendStatics(d, b) {
    _extendStatics = Object.setPrototypeOf || {
      __proto__: []
    } instanceof Array && function (d, b) {
      d.__proto__ = b;
    } || function (d, b) {
      for (var p in b) {
        if (b.hasOwnProperty(p)) d[p] = b[p];
      }
    };

    return _extendStatics(d, b);
  };

  return function (d, b) {
    _extendStatics(d, b);

    function __() {
      this.constructor = d;
    }

    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
}();

var __decorate = this && this.__decorate || function (decorators, target, key, desc) {
  var c = arguments.length,
      r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
      d;
  if ((typeof Reflect === "undefined" ? "undefined" : _typeof(Reflect)) === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);else for (var i = decorators.length - 1; i >= 0; i--) {
    if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
  }
  return c > 3 && r && Object.defineProperty(target, key, r), r;
};

import * as React from 'react';
import AvartarImg from '../../../../../components/common/avatarImg';
import { jumpPerson } from '../../../../../helper/jumpToPersonHome';
import ScrollWrap from '../../../../../components/common/scrollWrap';
import { getApiUrl, taker, getUserInfo } from '../../../../../helper';
import NoDataView from '../../../../../components/common/noDataView';
import widthProvider from '@beisen/react-width-provider';
import './orderList.css';
import ToolTip from '@beisen/tool-tip';

var ListItem =
/** @class */
function (_super) {
  __extends(ListItem, _super);

  function ListItem(p) {
    var _this = _super.call(this, p) || this;

    _this.handleThumbClick = function () {
      //点赞(接口返回再允许第二次点击)
      if (_this.isfetching) return;
      var _a = _this.state,
          ThumbUpCount = _a.ThumbUpCount,
          CanThumbUp = _a.CanThumbUp;
      var _b = _this.props,
          data = _b.data,
          fanwei = _b.fanwei;
      _this.isfetching = true;
      var urlStr = '';

      if (!CanThumbUp) {
        //取消赞
        urlStr = 'proxy/PostUPaaSCoreGateway/Like/CancelLike';
      } else {
        //点赞
        urlStr = 'proxy/PostUPaaSCoreGateway/Like/Like';
      }

      var url = getApiUrl(urlStr);
      var mapDianZan = [0, 1, 1, 2, 3, 4];
      taker(url, 'POST', {
        "appObj": {
          "AppObjId": data.User.UserId,
          "AppObjType": 9501005,
          "PeriodType": mapDianZan[fanwei],
          "ReceiverId": data.User.UserId
        }
      }).then(function (res) {
        _this.timeOut && clearTimeout(_this.timeOut);
        _this.timeOut = setTimeout(function () {
          _this.isfetching = false;
        }, 300);

        if (res.Code == 200) {
          //点赞｜取消赞结束，改状态。
          _this.setState({
            CanThumbUp: !CanThumbUp,
            ThumbUpCount: CanThumbUp ? ThumbUpCount + 1 : ThumbUpCount - 1
          });
        }
      });
    };

    _this.goSelfPage = function () {
      var data = _this.props.data;
      jumpPerson(data.User.UserId, 1);
    };

    _this.state = {
      CanThumbUp: p.data.CanThumbUp,
      ThumbUpCount: p.data.ThumbUpCount
    };
    return _this;
  }

  ListItem.prototype.componentWillReceiveProps = function (np) {
    var npCount = np.data.ThumbUpCount;
    var npCan = np.data.CanThumbUp;
    var _a = this.props.data,
        ThumbUpCount = _a.ThumbUpCount,
        CanThumbUp = _a.CanThumbUp;

    if (npCan != CanThumbUp || npCount != ThumbUpCount) {
      this.setState({
        CanThumbUp: npCan,
        ThumbUpCount: npCount
      });
    }
  };

  ListItem.prototype.render = function () {
    var _this = this;

    var _a = this.props,
        data = _a.data,
        index = _a.index,
        width = _a.width;
    var _b = this.state,
        ThumbUpCount = _b.ThumbUpCount,
        CanThumbUp = _b.CanThumbUp;
    var isSelf = getUserInfo().Id == data.User.UserId;
    return React.createElement("tr", {
      className: 'list-item'
    }, React.createElement("td", {
      className: "icon order" + index
    }, index > 2 ? index + 1 : ''), React.createElement("td", null), React.createElement("td", {
      className: 'head',
      onClick: this.goSelfPage
    }, React.createElement(AvartarImg, {
      size: 30,
      color: data.User.Avatar.Color,
      name: data.User.Name,
      src: data.User.Avatar.Original
    })), React.createElement("td", null), React.createElement("td", {
      className: 'name',
      onClick: this.goSelfPage
    }, React.createElement(ToolTip, {
      side: false,
      title: data.User.Name
    }, React.createElement("span", null, data.User.Name))), React.createElement("td", null), React.createElement("td", {
      className: 'describe',
      style: {
        display: width && width <= 290 ? 'none' : 'table-cell'
      }
    }, React.createElement("span", {
      className: 'des-describe'
    }), React.createElement("span", {
      className: 'des-time'
    }, "" + (data.RankBasis > 99 ? '99+' : data.RankBasis), "\u6B21")), React.createElement("td", {
      className: 'agree-number'
    }, React.createElement("div", {
      className: "agree-container"
    }, React.createElement("span", {
      className: "agree font-agree " + (CanThumbUp ? '' : 'agreed') + " " + (isSelf ? 'self-agree' : ''),
      onClick: function onClick() {
        !isSelf && _this.handleThumbClick();
      }
    }), React.createElement("span", {
      className: 'agree-count'
    }, "" + (ThumbUpCount > 99 ? '99+' : ThumbUpCount)))));
  };

  return ListItem;
}(React.Component);

var OrderList =
/** @class */
function (_super) {
  __extends(OrderList, _super);

  function OrderList() {
    return _super !== null && _super.apply(this, arguments) || this;
  }

  OrderList.prototype.render = function () {
    var _a = this.props,
        datas = _a.datas,
        fanwei = _a.fanwei,
        width = _a.width;

    if (!datas.length) {
      return React.createElement("div", {
        className: 'list-no-data'
      }, React.createElement(NoDataView, {
        icon: 2
      }));
    }

    var name = datas[0].User.Name;
    datas.map(function (d, k) {
      if (d.User.Name.length > name.length) {
        name = d.User.Name;
      }
    });
    return React.createElement("div", {
      className: 'bound-order-lists'
    }, React.createElement(ScrollWrap, {
      height: '100%'
    }, React.createElement("table", {
      className: 'order-table'
    }, React.createElement("colgroup", null, React.createElement("col", {
      width: '20px'
    }), React.createElement("col", {
      width: '20px'
    }), React.createElement("col", {
      width: '30px'
    }), React.createElement("col", {
      width: '10px'
    }), React.createElement("col", {
      width: "20px"
    }), React.createElement("col", {
      width: '27px'
    }), React.createElement("col", {
      width: '0px'
    }), React.createElement("col", {
      width: '35px'
    })), React.createElement("tbody", null, datas.map(function (data, index) {
      return React.createElement(ListItem, {
        data: data,
        index: index,
        key: "list-item" + index,
        fanwei: fanwei,
        width: width
      });
    })))));
  };

  OrderList = __decorate([widthProvider('width')], OrderList);
  return OrderList;
}(React.Component);

export default OrderList;